import { UseMutationOptions, UseQueryOptions } from 'react-query';
import { RequestMethod } from '../server/handler-types';
import { RequestConfig, RequestError, RouteDefinitions } from './request';
export declare function makeUseApiMutation<Routes extends RouteDefinitions, Method extends RequestMethod>(method: Method, buildTimeBaseUrl?: string): <Route extends keyof Routes>(route: Route, options?: (Omit<UseMutationOptions<Routes[Route]["api"]["data"], RequestError, import("../server/type-helpers").MakeObjectWithOptionalKeysUndefinable<import("../server/type-helpers").AddOptionalsToUndefined<import("../server/type-helpers").RemoveNever<{
    params: import("../server/type-helpers").EmptyRecordToNever<Routes[Route]["params"]>;
    query: Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["queryParams"]> : Record<string, string | string[]> | undefined;
    body: {
        GET: false;
        POST: true;
        PUT: true;
        PATCH: true;
        DELETE: false;
        HEAD: false;
        OPTIONS: false;
    }[Method] extends true ? Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["body"]> : string | number | boolean | object | undefined : never;
}>>>, unknown>, "mutationKey" | "mutationFn"> & {
    fetchOptions?: (RequestInit & {
        baseUrl?: string | undefined;
    }) | undefined;
}) | undefined) => import("react-query").UseMutationResult<Routes[Route]["api"]["data"], RequestError, import("../server/type-helpers").MakeObjectWithOptionalKeysUndefinable<import("../server/type-helpers").AddOptionalsToUndefined<import("../server/type-helpers").RemoveNever<{
    params: import("../server/type-helpers").EmptyRecordToNever<Routes[Route]["params"]>;
    query: Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["queryParams"]> : Record<string, string | string[]> | undefined;
    body: {
        GET: false;
        POST: true;
        PUT: true;
        PATCH: true;
        DELETE: false;
        HEAD: false;
        OPTIONS: false;
    }[Method] extends true ? Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["body"]> : string | number | boolean | object | undefined : never;
}>>>, unknown>;
export declare function makeUseApiQuery<Routes extends RouteDefinitions, Method extends RequestMethod>(method: Routes[string]['api']['method'], buildTimeBaseUrl?: string): <Route extends keyof Routes>(route: Route, variables: import("../server/type-helpers").MakeObjectWithOptionalKeysUndefinable<import("../server/type-helpers").AddOptionalsToUndefined<import("../server/type-helpers").RemoveNever<{
    params: import("../server/type-helpers").EmptyRecordToNever<Routes[Route]["params"]>;
    query: Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["queryParams"]> : Record<string, string | string[]> | undefined;
    body: {
        GET: false;
        POST: true;
        PUT: true;
        PATCH: true;
        DELETE: false;
        HEAD: false;
        OPTIONS: false;
    }[Method] extends true ? Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["body"]> : string | number | boolean | object | undefined : never;
}>>>, options?: (Omit<UseQueryOptions<Routes[Route]["api"]["data"], RequestError, Routes[Route]["api"]["data"], string>, "queryKey" | "queryFn"> & {
    fetchOptions?: (RequestInit & {
        baseUrl?: string | undefined;
    }) | undefined;
}) | undefined) => import("react-query").UseQueryResult<import("../server/type-helpers").MakeObjectWithOptionalKeysUndefinable<import("../server/type-helpers").AddOptionalsToUndefined<import("../server/type-helpers").RemoveNever<{
    params: import("../server/type-helpers").EmptyRecordToNever<Routes[Route]["params"]>;
    query: Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["queryParams"]> : Record<string, string | string[]> | undefined;
    body: {
        GET: false;
        POST: true;
        PUT: true;
        PATCH: true;
        DELETE: false;
        HEAD: false;
        OPTIONS: false;
    }[Method] extends true ? Routes[Route]["api"]["typeSafe"] extends true ? import("../server/type-helpers").ObjectToNever<Routes[Route]["api"]["body"]> : string | number | boolean | object | undefined : never;
}>>>, RequestError>;
